## mingw-w64-wt-4.11.1-1.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13...3.22)

SET(CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE true)

PROJECT(WT)

SET(CMAKE_MODULE_PATH
  ${CMAKE_MODULE_PATH}
  ${WT_SOURCE_DIR}
  ${WT_SOURCE_DIR}/cmake
)

SET(VERSION_SERIES 4)
SET(VERSION_MAJOR 11)
SET(VERSION_MINOR 1)

IF(NOT SHARED_LIBS)
  IF(WIN32)
    OPTION(SHARED_LIBS "Compile shared libraries" OFF)
  ELSE(WIN32)
    OPTION(SHARED_LIBS "Compile shared libraries" ON)
  ENDIF(WIN32)
ENDIF(NOT SHARED_LIBS)

#
# Various things that must be configured by the user or packager ...
#
OPTION(BUILD_EXAMPLES "Build examples" ON)
OPTION(INSTALL_DOCUMENTATION "Install documentation (tutorials and reference)" OFF)
OPTION(INSTALL_EXAMPLES "Install examples (binaries and source)" OFF)
OPTION(INSTALL_RESOURCES "Install resources directory" ON)
option(INSTALL_THEMES "Install the source files for Wt's themes" ON)
OPTION(ENABLE_SSL "Enable cryptography functions, using OpenSSL" ON)
OPTION(ENABLE_HARU "Enable Haru Free PDF Library, which is used to provide support for painting to PDF (WPdfImage)" ON)
OPTION(ENABLE_PANGO "Enable Pango Library, which is used for improved font support (WPdfImage and WRasterImage)" ON)
OPTION(ENABLE_SQLITE "Build SQLite3 backend for Wt::Dbo" ON)
OPTION(ENABLE_POSTGRES "Build PostgreSQL backend for Wt::Dbo" ON)
OPTION(ENABLE_FIREBIRD "Build FirebirdSQL backend for Wt::Dbo" ON)
OPTION(ENABLE_MYSQL "Build mariadb/mysql backend for Wt::Dbo" ON)
OPTION(ENABLE_MSSQLSERVER "Build Microsoft SQL Server backend for Wt::Dbo" ON)
OPTION(ENABLE_QT4 "Build Qt4 interworking library (libwtwithqt)" ON)
OPTION(ENABLE_QT5 "Build Qt5 interworking library (libwtwithqt5)" ON)
OPTION(ENABLE_QT6 "Build Qt6 interworking library (libwtwithqt6)" ON)
OPTION(ENABLE_SAML "Build built-in SAML service provider for Wt::Auth" OFF)
OPTION(ENABLE_LIBWTTEST "Build Wt::Test" ON)
OPTION(ENABLE_LIBWTDBO "Build Wt::Dbo" ON)
OPTION(ENABLE_OPENGL "Build Wt with support for server-side opengl rendering" ON)
OPTION(ENABLE_UNWIND "Build Wt with stacktrace support using libunwind" OFF)

option(DEBUG_JS "Serve non-minified JavaScript from the filesystem instead of embedding it, for debugging." OFF)
mark_as_advanced(DEBUG_JS)

IF(NOT CMAKE_CXX_STANDARD)
  SET(CMAKE_CXX_STANDARD 14)
ENDIF(NOT CMAKE_CXX_STANDARD)
SET(CMAKE_CXX_STANDARD_REQUIRED ON)
SET(CMAKE_CXX_EXTENSIONS OFF)

IF(MSVC)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /bigobj")
  SET_PROPERTY(GLOBAL PROPERTY USE_FOLDERS ON)
ENDIF(MSVC)

IF(APPLE)
  OPTION(USE_BOOST_FRAMEWORK "Uses a Boost framework" OFF)
ENDIF(APPLE)

IF(NOT DOCUMENTATION_DESTINATION)
  SET(DOCUMENTATION_DESTINATION share/doc/Wt)
ENDIF(NOT DOCUMENTATION_DESTINATION)
IF(NOT EXAMPLES_DESTINATION)
  SET(EXAMPLES_DESTINATION lib/Wt/examples)
ENDIF(NOT EXAMPLES_DESTINATION)

IF(WIN32)
  # required for all that uses boost.asio
  ADD_DEFINITIONS(-D_WIN32_WINNT=0x0600)

  IF(SHARED_LIBS)
    # See http://svn.boost.org/trac/boost/ticket/3465
    SET(WT_NO_BOOST_INTRUSIVE true)
  ENDIF(SHARED_LIBS)
ENDIF(WIN32)

# Fixup Windows declspec stuff
IF(NOT SHARED_LIBS)
  SET(WT_STATIC true)
  SET(WTHTTP_STATIC true)
  SET(WT_EXT_STATIC true)
  SET(WTDBO_STATIC true)
  SET(WTDBOSQLITE3_STATIC true)
  SET(WTDBOPOSTGRES_STATIC true)
  SET(WTDBOFIREBIRD_STATIC true)
  SET(WTDBOMYSQL_STATIC true)
  SET(WTDBOMSSQLSERVER_STATIC true)
ENDIF(NOT SHARED_LIBS)

IF(NOT MULTI_THREADED)
  OPTION(MULTI_THREADED "Build multi-threaded httpd deamon (if possible)" ON)
ENDIF(NOT MULTI_THREADED)

SET(BUILD_SHARED_LIBS ${SHARED_LIBS})

SET(DEBUG_LIB_POSTFIX "d" CACHE STRING "String appended to debug libraries")

SET(LIB_INSTALL_DIR "lib" CACHE STRING
  "Name for library directory within ${CMAKE_INSTALL_PREFIX}")

SET(CMAKE_INSTALL_DIR "${LIB_INSTALL_DIR}/cmake" CACHE STRING
  "Name for CMake package configuration directory within ${CMAKE_INSTALL_PREFIX}")

IF(WIN32)

  SET(RUNDIR "c:/witty") # Does not apply to win32

  IF(NOT DEFINED CONFIGDIR)
    SET(CONFIGDIR ${RUNDIR} CACHE STRING "Path for the configuration files")
  ENDIF(NOT DEFINED CONFIGDIR)

  SET(USERLIB_PREFIX_DEFAULT "c:/libraries")
  IF(MSVC)
    SET(BUILD_PARALLEL "/MP" CACHE STRING "MSVC option for parallel builds (/MP or /MPx)")
  ENDIF(MSVC)

ELSE(WIN32)

  IF("${CMAKE_INSTALL_PREFIX}" STREQUAL "/usr")
    SET(CONFIG_PREFIX "")
  ELSEIF("${CMAKE_INSTALL_PREFIX}" STREQUAL "/usr/local")
    SET(CONFIG_PREFIX "")
  ELSE()
    SET(CONFIG_PREFIX ${CMAKE_INSTALL_PREFIX})
  ENDIF()

  SET(RUNDIR "${CONFIG_PREFIX}/var/run/wt" CACHE PATH
    "Default path for wt session management (only used by FCGI connector)")

  IF(NOT DEFINED CONFIGDIR)
    SET(CONFIGDIR "${CONFIG_PREFIX}/etc/wt" CACHE STRING "Path for the configuration files")
  ENDIF( NOT DEFINED CONFIGDIR )

  # If the user specifies the standard CMAKE_PREFIX_PATH to find packages,
  # honour it.
  IF(CMAKE_PREFIX_PATH)
    SET(USERLIB_PREFIX_DEFAULT ${CMAKE_PREFIX_PATH})
  ELSE()
    SET(USERLIB_PREFIX_DEFAULT "/usr")
  ENDIF()

ENDIF(WIN32)

IF(DEFINED USERLIB_ROOT) # Deprecated <= 3.1.3
  SET(USERLIB_PREFIX ${USERLIB_ROOT} CACHE PATH
    "Installation prefix of dependency libraries (by USERLIB_ROOT)")
ELSE(DEFINED USERLIB_ROOT)
  SET(USERLIB_PREFIX ${USERLIB_PREFIX_DEFAULT} CACHE PATH
    "Installation prefix of dependency libraries")
ENDIF(DEFINED USERLIB_ROOT)

IF(WIN32)
  SET(BOOST_PREFIX_DEFAULT "c:/Program Files/Boost")
  OPTION(BOOST_DYNAMIC "Link to boost DLLs (OFF means static link)" OFF)
  OPTION(HARU_DYNAMIC "Link to libharu DLLs (OFF means static link)" OFF)
ELSE(WIN32)
  SET(BOOST_PREFIX_DEFAULT ${USERLIB_PREFIX})
ENDIF(WIN32)

IF(DEFINED BOOST_DIR) # Deprecated <= 3.1.3
  SET(BOOST_PREFIX ${BOOST_DIR} CACHE PATH
    "Installation prefix of boost libraries (by BOOST_DIR)")
ELSE(DEFINED BOOST_DIR)
  SET(BOOST_PREFIX ${BOOST_PREFIX_DEFAULT} CACHE PATH
    "Installation prefix of boost libraries")
ENDIF(DEFINED BOOST_DIR)

SET(FCGI_PREFIX ${USERLIB_PREFIX} CACHE PATH
  "Installation prefix of fcgi library (overrides USERLIB_PREFIX)")
SET(POSTGRES_PREFIX ${USERLIB_PREFIX} CACHE PATH
  "Installation prefix of postgresql library (overrides USERLIB_PREFIX)")
SET(ODBC_PREFIX ${USERLIB_PREFIX} CACHE PATH
  "Installation prefix of ODBC (unixODBC), required for MS SQL Server, not necessary on Windows (overrides USERLIB_PREFIX)")
SET(FIREBIRD_PREFIX ${USERLIB_PREFIX} CACHE PATH
  "Installation prefix of FirebirdSql library. (overrides USERLIB_PREFIX)")
SET(IBPP_SRC_DIRECTORY CACHE PATH
  "Path to the SOURCE directory of the IBPP library (C++ Firebird client library, see ibpp.org), Wt includes an ibpp distribution which is used by default. To use a custom IBPP library configure this variable and enable the USE_SYSTEM_IBPP option.")
SET(MYSQL_PREFIX ${USERLIB_PREFIX} CACHE PATH
  "Installation prefix of mariadb client libraries (overrides USERLIB_PREFIX)")
SET(SQLITE3_PREFIX ${USERLIB_PREFIX} CACHE PATH
  "Installation prefix of sqlite3 library (overrides USERLIB_PREFIX)")
SET(HARU_PREFIX ${USERLIB_PREFIX} CACHE PATH
  "Installation prefix of libharu library (overrides USERLIB_PREFIX)")
SET(SSL_PREFIX ${USERLIB_PREFIX} CACHE PATH
  "Installation prefix of SSL library (overrides USERLIB_PREFIX)")
SET(ZLIB_PREFIX ${USERLIB_PREFIX} CACHE PATH
  "Installation prefix of zlib library (overrides USERLIB_PREFIX)")
SET(GM_PREFIX ${USERLIB_PREFIX} CACHE PATH
  "Installation prefix of GraphicsMagick library (overrides USERLIB_PREFIX)")
SET(ASIO_PREFIX ${USERLIB_PREFIX} CACHE PATH
  "Prefix of Asio (overrides USERLIB_PREFIX), only used when WT_ASIO_IMPLEMENTATION is standalone")
SET(UNWIND_PREFIX ${UNWIND_PREFIX} CACHE PATH
  "Prefix of unwind library (overrides USERLIB_PREFIX)")

OPTION(DEBUG "Support for debugging, must be enabled also in wt_config.xml" OFF)

IF(CYGWIN)
  OPTION(BUILD_TESTS "Build Wt tests" OFF)
ELSE(CYGWIN)
  OPTION(BUILD_TESTS "Build Wt tests" ON)
ENDIF(CYGWIN)

OPTION(BUILD_FUZZ "Build Wt fuzzers" OFF)

ADD_DEFINITIONS(-DWT_WITH_OLD_INTERNALPATH_API)
IF(CYGWIN)
  ADD_DEFINITIONS(-D__USE_W32_SOCKETS)
ENDIF(CYGWIN)

MARK_AS_ADVANCED( CONFIGDIR )

SET(CONFIGURATION "${CONFIGDIR}/wt_config.xml" CACHE PATH "Path to the wt configuration file")
SET(WTHTTP_CONFIGURATION "${CONFIGDIR}/wthttpd" CACHE PATH "Path for the wthttpd configuration file")

SET(WEBUSER apache CACHE STRING "Webserver username (e.g. apache or www)")
SET(WEBGROUP apache CACHE STRING "Webserver groupname (e.g. apache or www or users)")
IF(WIN32)
  SET(CONNECTOR_FCGI FALSE)
  IF(NOT MINGW)
    OPTION(CONNECTOR_ISAPI "Compile in ISAPI connector (libwtisapi) ?" ON)
  ENDIF(NOT MINGW)
ELSE(WIN32)
  OPTION(CONNECTOR_FCGI "Compile in FCGI connector (libwtfcgi) ?" ON)
  SET(CONNECTOR_ISAPI OFF)
ENDIF(WIN32)
OPTION(CONNECTOR_HTTP "Compile in stand-alone httpd connector (libwthttp) ?" ON)
SET(EXAMPLES_CONNECTOR wthttp CACHE STRING "Connector used for examples")

include (CheckSymbolExists)

find_package(PNG)

set(ZLIB_ROOT ${ZLIB_PREFIX})
find_package(ZLIB)

INCLUDE(cmake/WtFindBoost.txt)
INCLUDE(cmake/WtFindFcgi.txt)
INCLUDE(cmake/WtFindMysql.txt)
INCLUDE(cmake/WtFindPostgresql.txt)
INCLUDE(cmake/WtFindOdbc.txt)
INCLUDE(cmake/WtFindGm.txt)

find_package(OpenGL)
find_package(GLEW)

find_package(Asciidoctor)

set(HPDF_ROOT ${HARU_PREFIX})
find_package(HPDF)

set(OPENSSL_ROOT_DIR ${SSL_PREFIX})
find_package(OpenSSL)

IF (ENABLE_SAML)
  find_package(OpenSAML)
  if(OpenSAML_FOUND)
    set(WT_HAS_SAML TRUE)
  endif()
ENDIF (ENABLE_SAML)

IF (ENABLE_UNWIND)
  INCLUDE(cmake/WtFindUnwind.txt)
ENDIF (ENABLE_UNWIND)

IF (ENABLE_PANGO)
  INCLUDE(cmake/WtFindPangoFt2.txt)
ENDIF (ENABLE_PANGO)

INCLUDE(cmake/WtFindSystemLibraries.txt)

IF(ENABLE_QT4)
  FIND_PACKAGE(Qt4)

  IF(QT_FOUND)
    INCLUDE(${QT_USE_FILE})
  ENDIF(QT_FOUND)
ENDIF(ENABLE_QT4)

IF(ENABLE_QT5)
  FIND_PACKAGE(Qt5Core)
ENDIF(ENABLE_QT5)

IF(ENABLE_QT6)
  FIND_PACKAGE(Qt6 CONFIG COMPONENTS Core)
ENDIF(ENABLE_QT6)

set(WT_THREAD_LIB "")
IF(MULTI_THREADED)
  find_package(Threads)
  set(WT_THREAD_LIB Threads::Threads)
ENDIF(MULTI_THREADED)

find_package(Atomics REQUIRED)

IF(NOT BOOST_WT_FOUND)
  SET(ERR
     "Could not find a boost installation in " ${BOOST_PREFIX} ".\n\n"
      "There are two methods in Wt to find boost:\n\n"
      "1. Find boost through cmake (recommended)\n"
      "This requires cmake 2.6, and is in "
      "that case the default (unless BOOST_COMPILER or BOOST_VERSION is "
      "defined). This method requires a multi-threaded boost installation.\n"
      "You may need to add your boost version number to "
      "Boost_ADDITIONAL_VERSIONS, and/or set BOOST_PREFIX to the location "
      "where boost is installed.\n\n"
      "2. Use the Wt-proprietary method to find boost.\n"
      "This requires you to define three variables:\n"
      "BOOST_PREFIX: set to the directory where you installed boost\n"
      "BOOST_COMPILER: set to the compiler signature as you find them in "
      "library names (e.g.: gcc42)\n"
      "BOOST_VERSION: set to the boost version, again as you find them in "
      "the library names (e.g.: 1_38)\n\n"
      "Note 1: the code to discover boost is located in cmake/WtFindBoost.txt\n"
      "Note 2: on windows, set BOOST_PREFIX to the full path, eg "
      "c:/Program Files/boost/boost_1_65_1")
  MESSAGE(FATAL_ERROR ${ERR})
ENDIF(NOT BOOST_WT_FOUND)

IF(BOOST_WT_MT_FOUND)
  IF(MULTI_THREADED)
    MESSAGE("** Enabling multi threading.")
    SET(MULTI_THREADED_BUILD true)
    SET(WT_THREADED true)
    ADD_DEFINITIONS(-D_REENTRANT -DBOOST_SPIRIT_THREADSAFE)
  ELSE(MULTI_THREADED)
    MESSAGE("** Disabling multi threading.")
    SET(MULTI_THREADED_BUILD false)

    ADD_DEFINITIONS(-DBOOST_DISABLE_THREADS -DSQLITE_THREADSAFE=0)
  ENDIF(MULTI_THREADED)
ELSE(BOOST_WT_MT_FOUND)
  SET(MULTI_THREADED_BUILD false)
  MESSAGE("** Disabling multi threading: could not find multi-threaded boost libraries")
  ADD_DEFINITIONS(-DBOOST_DISABLE_THREADS -DSQLITE_THREADSAFE=0)
ENDIF(BOOST_WT_MT_FOUND)

IF (WIN32)
  SET(WT_WRASTERIMAGE_DEFAULT_IMPLEMENTATION "Direct2D")
ELSE (WIN32)

=== src/CMakeLists.txt ===
SUBDIRS(web Wt)

INCLUDE_DIRECTORIES(
  ${CMAKE_CURRENT_SOURCE_DIR}/web
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/Wt/Date/include
  ${CMAKE_CURRENT_BINARY_DIR} # for WConfig.h
  ${BOOST_INCLUDE_DIRS}
  Wt/Dbo/backend/amalgamation # for sqlite3.h
  ${CMAKE_CURRENT_SOURCE_DIR}/thirdparty/qrcodegen # QR code generation for MFA
)

LINK_DIRECTORIES(${BOOST_LIB_DIRS})

function(file_to_string infile outfile var)
  add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${outfile}
    COMMAND ${CMAKE_COMMAND}
      ARGS -Dinfile:FILEPATH=${CMAKE_CURRENT_SOURCE_DIR}/${infile}
           -Doutfile:FILEPATH=${CMAKE_CURRENT_BINARY_DIR}/${outfile}
           -Dvar:STRING=${var}
           -P ${CMAKE_CURRENT_SOURCE_DIR}/filetostring.cmake
    MAIN_DEPENDENCY
      ${CMAKE_CURRENT_SOURCE_DIR}/${infile}
    DEPENDS
      ${CMAKE_CURRENT_SOURCE_DIR}/filetostring.cmake
  )
endfunction()

FILE_TO_STRING(web/skeleton/Plain.html    Plain_html.C      Plain_html)
FILE_TO_STRING(web/skeleton/Hybrid.html   Hybrid_html.C     Hybrid_html)
FILE_TO_STRING(web/skeleton/Boot.html     Boot_html.C       Boot_html)

IF(CMAKE_BUILD_TYPE STREQUAL "Debug")
  FILE_TO_STRING(web/skeleton/Wt.js     Wt_js.C Wt_js)
ELSE(CMAKE_BUILD_TYPE STREQUAL "Debug")
  FILE_TO_STRING(web/skeleton/Wt.min.js Wt_js.C Wt_js)
ENDIF(CMAKE_BUILD_TYPE STREQUAL "Debug")

IF(CMAKE_BUILD_TYPE STREQUAL "Debug")
  FILE_TO_STRING(web/skeleton/Boot.js     Boot_js.C Boot_js)
ELSE(CMAKE_BUILD_TYPE STREQUAL "Debug")
  FILE_TO_STRING(web/skeleton/Boot.min.js Boot_js.C Boot_js)
ENDIF(CMAKE_BUILD_TYPE STREQUAL "Debug")

IF(CMAKE_BUILD_TYPE STREQUAL "Debug")
  FILE_TO_STRING(js/WCartesianChart.js WCartesianChart_js.C WCartesianChart_js)
ELSE(CMAKE_BUILD_TYPE STREQUAL "Debug")
  FILE_TO_STRING(js/WCartesianChart.min.js WCartesianChart_js.C WCartesianChart_js)
ENDIF(CMAKE_BUILD_TYPE STREQUAL "Debug")

FILE_TO_STRING(xml/wt.xml Wt_xml.C Wt_xml)
FILE_TO_STRING(xml/auth_strings.xml AuthStrings_xml.C AuthStrings_xml)
FILE_TO_STRING(xml/bootstrap_theme.xml
    BootstrapTheme_xml.C BootstrapTheme_xml)
FILE_TO_STRING(xml/bootstrap3_theme.xml
    Bootstrap3Theme_xml.C Bootstrap3Theme_xml)
FILE_TO_STRING(xml/bootstrap5_theme.xml
    Bootstrap5Theme_xml.C Bootstrap5Theme_xml)
FILE_TO_STRING(xml/auth_css_theme.xml
    AuthCssTheme_xml.C AuthCssTheme_xml)

SET(libsources
Wt/FlexLayoutImpl.h Wt/FlexLayoutImpl.C
Wt/FlexItemImpl.h Wt/FlexItemImpl.C
Wt/PopupWindow.h Wt/PopupWindow.C
Wt/Resizable.h Wt/Resizable.C
Wt/ResizeSensor.h Wt/ResizeSensor.C
Wt/ServerSideFontMetrics.h Wt/ServerSideFontMetrics.C
Wt/SizeHandle.h Wt/SizeHandle.C
Wt/StdGridLayoutImpl2.h Wt/StdGridLayoutImpl2.C
Wt/StdLayoutImpl.h Wt/StdLayoutImpl.C
Wt/StdLayoutItemImpl.h Wt/StdLayoutItemImpl.C
Wt/StdWidgetItemImpl.h Wt/StdWidgetItemImpl.C
Wt/Utils.h Wt/Utils.C
Wt/WAbstractArea.h Wt/WAbstractArea.C
Wt/WAbstractItemDelegate.h Wt/WAbstractItemDelegate.C
Wt/WAbstractItemModel.h Wt/WAbstractItemModel.C
Wt/WAbstractItemView.h Wt/WAbstractItemView.C
Wt/WAbstractListModel.h Wt/WAbstractListModel.C
Wt/WAbstractMedia.h Wt/WAbstractMedia.C
Wt/WAbstractProxyModel.h Wt/WAbstractProxyModel.C
Wt/WAbstractSpinBox.h Wt/WAbstractSpinBox.C
Wt/WAbstractTableModel.h Wt/WAbstractTableModel.C
Wt/WAbstractToggleButton.h Wt/WAbstractToggleButton.C
Wt/WAggregateProxyModel.h Wt/WAggregateProxyModel.C
Wt/WAnchor.h Wt/WAnchor.C
Wt/WAnimation.h Wt/WAnimation.C
Wt/WAny.h Wt/WAny.C
Wt/WApplication.h Wt/WApplication.C
Wt/WAudio.h Wt/WAudio.C
Wt/WBatchEditProxyModel.h Wt/WBatchEditProxyModel.C
Wt/WBootstrapTheme.h Wt/WBootstrapTheme.C
Wt/WBootstrap2Theme.h Wt/WBootstrap2Theme.C
Wt/WBootstrap3Theme.h Wt/WBootstrap3Theme.C
Wt/WBootstrap5Theme.h Wt/WBootstrap5Theme.C
Wt/WBorder.h Wt/WBorder.C
Wt/WBorderLayout.h Wt/WBorderLayout.C
Wt/WBoxLayout.h Wt/WBoxLayout.C
Wt/WBreak.h Wt/WBreak.C
Wt/WBrush.h Wt/WBrush.C
Wt/WButtonGroup.h Wt/WButtonGroup.C
Wt/WCalendar.h Wt/WCalendar.C
Wt/WCanvasPaintDevice.h Wt/WCanvasPaintDevice.C
Wt/WCheckBox.h Wt/WCheckBox.C
Wt/WCircleArea.h Wt/WCircleArea.C
Wt/WColor.h Wt/WColor.C
Wt/WColorPicker.h Wt/WColorPicker.C
Wt/WCombinedLocalizedStrings.h Wt/WCombinedLocalizedStrings.C
Wt/WComboBox.h Wt/WComboBox.C
Wt/WCompositeWidget.h Wt/WCompositeWidget.C
Wt/WContainerWidget.h Wt/WContainerWidget.C
Wt/WCssDecorationStyle.h Wt/WCssDecorationStyle.C
Wt/WCssStyleSheet.h Wt/WCssStyleSheet.C
Wt/WCssTheme.h Wt/WCssTheme.C
Wt/WDate.h Wt/WDate.C
Wt/WDateEdit.h Wt/WDateEdit.C
Wt/WDatePicker.h Wt/WDatePicker.C
Wt/WDateTime.h Wt/WDateTime.C
Wt/WDateValidator.h Wt/WDateValidator.C
Wt/WDefaultLoadingIndicator.h Wt/WDefaultLoadingIndicator.C
Wt/WDialog.h Wt/WDialog.C
Wt/WDoubleSpinBox.h Wt/WDoubleSpinBox.C
Wt/WDoubleValidator.h Wt/WDoubleValidator.C
Wt/WEmailEdit.h Wt/WEmailEdit.C
Wt/WEmailValidator.h Wt/WEmailValidator.C
Wt/WEnvironment.h Wt/WEnvironment.C
Wt/WEvent.h Wt/WEvent.C
Wt/WException.h Wt/WException.C
Wt/WFileDropWidget.h Wt/WFileDropWidget.C
Wt/WFileResource.h Wt/WFileResource.C
Wt/WFileUpload.h Wt/WFileUpload.C
Wt/WFitLayout.h Wt/WFitLayout.C
Wt/WFlashObject.h Wt/WFlashObject.C
Wt/WFont.h Wt/WFont.C
Wt/WFontMetrics.h Wt/WFontMetrics.C
Wt/WFormModel.h Wt/WFormModel.C
Wt/WFormWidget.h Wt/WFormWidget.C
Wt/WGLWidget.h Wt/WGLWidget.C
Wt/WAbstractGLImplementation.h Wt/WAbstractGLImplementation.C
Wt/WClientGLWidget.h Wt/WClientGLWidget.C
Wt/WGoogleMap.h Wt/WGoogleMap.C
Wt/WGradient.h Wt/WGradient.C
Wt/WGridLayout.h Wt/WGridLayout.C
Wt/WGroupBox.h Wt/WGroupBox.C
Wt/WHBoxLayout.h Wt/WHBoxLayout.C
Wt/WIcon.h Wt/WIcon.C
Wt/WIconPair.h Wt/WIconPair.C
Wt/WImage.h Wt/WImage.C
Wt/WInPlaceEdit.h Wt/WInPlaceEdit.C
Wt/WIntValidator.h Wt/WIntValidator.C
Wt/WInteractWidget.h Wt/WInteractWidget.C
Wt/WIOService.h Wt/WIOService.C
Wt/WLocale.h Wt/WLocale.C
Wt/WLocalDateTime.h Wt/WLocalDateTime.C
Wt/WIdentityProxyModel.h Wt/WIdentityProxyModel.C
Wt/WItemDelegate.h Wt/WItemDelegate.C
Wt/WItemSelectionModel.h Wt/WItemSelectionModel.C
Wt/WJavaScript.h Wt/WJavaScript.C
Wt/WJavaScriptExposableObject.h Wt/WJavaScriptExposableObject.C
Wt/WJavaScriptHandle.h Wt/WJavaScriptHandle.C
Wt/WJavaScriptObjectStorage.h Wt/WJavaScriptObjectStorage.C
Wt/WJavaScriptPreamble.h Wt/WJavaScriptPreamble.C
Wt/WJavaScriptSlot.h Wt/WJavaScriptSlot.C
Wt/WLabel.h Wt/WLabel.C
Wt/WLayout.h Wt/WLayout.C
Wt/WLayoutImpl.h Wt/WLayoutImpl.C
Wt/WLayoutItem.h Wt/WLayoutItem.C
Wt/WLayoutItemImpl.h Wt/WLayoutItemImpl.C
Wt/WLeafletMap.h Wt/WLeafletMap.C
Wt/WLength.h Wt/WLength.C
Wt/WLengthValidator.h Wt/WLengthValidator.C
Wt/WLineEdit.h Wt/WLineEdit.C
Wt/WLineF.h Wt/WLineF.C
Wt/WLink.h Wt/WLink.C
Wt/WLinkedCssStyleSheet.h Wt/WLinkedCssStyleSheet.C
Wt/WLoadingIndicator.h Wt/WLoadingIndicator.C
Wt/WLocalizedStrings.h Wt/WLocalizedStrings.C
Wt/WLogger.h Wt/WLogger.C
Wt/WLogSink.h Wt/WLogSink.C
Wt/WMatrix4x4.h Wt/WMatrix4x4.C
Wt/WMeasurePaintDevice.h Wt/WMeasurePaintDevice.C
Wt/WMediaPlayer.h Wt/WMediaPlayer.C
Wt/WMemoryResource.h Wt/WMemoryResource.C
Wt/WMenu.h Wt/WMenu.C
Wt/WMenuItem.h Wt/WMenuItem.C
Wt/WMessageBox.h Wt/WMessageBox.C
Wt/WMessageResourceBundle.h Wt/WMessageResourceBundle.C
Wt/WMessageResources.h Wt/WMessageResources.C
Wt/WModelIndex.h Wt/WModelIndex.C
Wt/WNavigationBar.h Wt/WNavigationBar.C
Wt/WObject.h Wt/WObject.C
Wt/WOverlayLoadingIndicator.h Wt/WOverlayLoadingIndicator.C
Wt/WPaintDevice.h Wt/WPaintDevice.C
Wt/WPaintedWidget.h Wt/WPaintedWidget.C
Wt/WPainter.h Wt/WPainter.C
Wt/WPainterPath.h Wt/WPainterPath.C
Wt/WPanel.h Wt/WPanel.C
Wt/WPen.h Wt/WPen.C
Wt/WPoint.h Wt/WPoint.C
Wt/WPointF.h Wt/WPointF.C
Wt/WPolygonArea.h Wt/WPolygonArea.C
Wt/WPopupMenu.h Wt/WPopupMenu.C
Wt/WPopupWidget.h Wt/WPopupWidget.C
Wt/WProgressBar.h Wt/WProgressBar.C
Wt/WPushButton.h Wt/WPushButton.C
Wt/WRadioButton.h Wt/WRadioButton.C
Wt/WRandom.h Wt/WRandom.C
Wt/WReadOnlyProxyModel.h Wt/WReadOnlyProxyModel.C
Wt/WRectArea.h Wt/WRectArea.C
Wt/WRectF.h Wt/WRectF.C
Wt/WRegExpValidator.h Wt/WRegExpValidator.C
Wt/WResource.h Wt/WResource.C
Wt/WSelectionBox.h Wt/WSelectionBox.C
Wt/WServer.h Wt/WServer.C
Wt/WShadow.h Wt/WShadow.C
Wt/WSignal.h Wt/WSignal.C
Wt/WSlider.h Wt/WSlider.C
Wt/WSocketNotifier.h Wt/WSocketNotifier.C
Wt/WSortFilterProxyModel.h Wt/WSortFilterProxyModel.C
Wt/WSpinBox.h Wt/WSpinBox.C
Wt/WSplitButton.h Wt/WSplitButton.C
Wt/WSound.h Wt/WSound.C
Wt/WSslCertificate.h Wt/WSslCertificate.C
Wt/WSslInfo.h Wt/WSslInfo.C
Wt/WStackedWidget.h Wt/WStackedWidget.C
Wt/WStandardItem.h Wt/WStandardItem.C
Wt/WStandardItemModel.h Wt/WStandardItemModel.C
Wt/WStatelessSlot.h Wt/WStatelessSlot.C
Wt/WString.h Wt/WString.C
Wt/WStreamResource.h Wt/WStreamResource.C
Wt/WStringListModel.h Wt/WStringListModel.C
Wt/WStringStream.h Wt/WStringStream.C
Wt/WStringUtil.h Wt/WStringUtil.C
Wt/WSuggestionPopup.h Wt/WSuggestionPopup.C
Wt/WSvgImage.h Wt/WSvgImage.C
Wt/WTabWidget.h Wt/WTabWidget.C
Wt/WTable.h Wt/WTable.C
Wt/WTableCell.h Wt/WTableCell.C
Wt/WTableColumn.h Wt/WTableColumn.C
Wt/WTableRow.h Wt/WTableRow.C
Wt/WTemplate.h Wt/WTemplate.C
Wt/WTemplateFormView.h Wt/WTemplateFormView.C
Wt/WTableView.h Wt/WTableView.C
Wt/WText.h Wt/WText.C
Wt/WTextArea.h Wt/WTextArea.C
Wt/WTextEdit.h Wt/WTextEdit.C
Wt/WTheme.h Wt/WTheme.C
Wt/WTime.h Wt/WTime.C
Wt/WTimeEdit.h Wt/WTimeEdit.C
Wt/WTimer.h Wt/WTimer.C
Wt/WTimerWidget.h Wt/WTimerWidget.C
Wt/WTimePicker.h Wt/WTimePicker.C
Wt/WTimeValidator.h Wt/WTimeValidator.C
Wt/WToolBar.h Wt/WToolBar.C
Wt/WTransform.h Wt/WTransform.C
Wt/WTree.h Wt/WTree.C
Wt/WTreeNode.h Wt/WTreeNode.C
Wt/WTreeTable.h Wt/WTreeTable.C
Wt/WTreeTableNode.h Wt/WTreeTableNode.C
Wt/WTreeView.h Wt/WTreeView.C
Wt/WValidator.h Wt/WValidator.C
Wt/WVBoxLayout.h Wt/WVBoxLayout.C
Wt/WVector3.h Wt/WVector3.C
Wt/WVector4.h Wt/WVector4.C
Wt/WVectorImage.h Wt/WVectorImage.C
Wt/WVideo.h Wt/WVideo.C
Wt/WVmlImage.h Wt/WVmlImage.C
Wt/WViewWidget.h Wt/WViewWidget.C
Wt/WVirtualImage.h Wt/WVirtualImage.C
Wt/WWebSocketConnection.h Wt/WWebSocketConnection.C
Wt/WWebSocketResource.h Wt/WWebSocketResource.C
Wt/WWebWidget.h Wt/WWebWidget.C
Wt/WWidget.h Wt/WWidget.C
Wt/WWidgetItem.h Wt/WWidgetItem.C
Wt/WWidgetItemImpl.h Wt/WWidgetItemImpl.C
thirdparty/qrcodegen/QrCode.hpp thirdparty/qrcodegen/QrCode.cpp
Wt/Auth/Mfa/AbstractMfaProcess.h Wt/Auth/Mfa/AbstractMfaProcess.C
Wt/Auth/Mfa/Totp.h Wt/Auth/Mfa/Totp.C
Wt/Auth/Mfa/TotpProcess.h Wt/Auth/Mfa/TotpProcess.C
Wt/Auth/Mfa/TotpQrCode.h Wt/Auth/Mfa/TotpQrCode.C
Wt/Auth/AbstractPasswordService.h Wt/Auth/AbstractPasswordService.C
Wt/Auth/AbstractUserDatabase.h Wt/Auth/AbstractUserDatabase.C
Wt/Auth/AuthModel.h Wt/Auth/AuthModel.C
Wt/Auth/AuthService.h Wt/Auth/AuthService.C
Wt/Auth/AuthThrottle.h Wt/Auth/AuthThrottle.C
Wt/Auth/AuthWidget.h Wt/Auth/AuthWidget.C
Wt/Auth/FacebookService.h Wt/Auth/FacebookService.C
Wt/Auth/FormBaseModel.h Wt/Auth/FormBaseModel.C
Wt/Auth/GoogleService.h Wt/Auth/GoogleService.C
Wt/Auth/HashFunction.h Wt/Auth/HashFunction.C
Wt/Auth/Identity.h Wt/Auth/Identity.C
Wt/Auth/Login.h Wt/Auth/Login.C
Wt/Auth/LostPasswordWidget.h Wt/Auth/LostPasswordWidget.C
Wt/Auth/OAuthService.h Wt/Auth/OAuthService.C
Wt/Auth/OAuthWidget.h Wt/Auth/OAuthWidget.C
Wt/Auth/passwdqc.h Wt/Auth/passwdqc_check.c
Wt/Auth/PasswordHash.h Wt/Auth/PasswordHash.C
Wt/Auth/PasswordPromptDialog.h Wt/Auth/PasswordPromptDialog.C
Wt/Auth/PasswordService.h Wt/Auth/PasswordService.C
Wt/Auth/PasswordStrengthValidator.h Wt/Auth/PasswordStrengthValidator.C
Wt/Auth/PasswordVerifier.h Wt/Auth/PasswordVerifier.C
Wt/Auth/RegistrationModel.h Wt/Auth/RegistrationModel.C
Wt/Auth/RegistrationWidget.h Wt/Auth/RegistrationWidget.C
Wt/Auth/ResendEmailVerificationWidget.h Wt/Auth/ResendEmailVerificationWidget.C
Wt/Auth/Token.h Wt/Auth/Token.C
Wt/Auth/UpdatePasswordWidget.h Wt/Auth/UpdatePasswordWidget.C
Wt/Auth/User.h Wt/Auth/User.C
Wt/Auth/AuthUtils.h Wt/Auth/AuthUtils.C
Wt/Auth/MailUtils.h Wt/Auth/MailUtils.C
Wt/Auth/OAuthClient.h Wt/Auth/OAuthClient.C
Wt/Auth/OAuthTokenEndpoint.h Wt/Auth/OAuthTokenEndpoint.C
Wt/Auth/OidcUserInfoEndpoint.h Wt/Auth/OidcUserInfoEndpoint.C
Wt/Auth/OAuthAuthorizationEndpointProcess.h Wt/Auth/OAuthAuthorizationEndpointProcess.C

=== test/CMakeLists.txt ===
IF(ENABLE_LIBWTTEST)
  SET(TEST_SOURCES
    test.C
    any/AnyTest.C
    auth/BCryptTest.C
    auth/SHA1Test.C
    auth/TotpTest.C
    configuration/EntryPointTest.C
    core/BindTest.C
    core/ObservingPtrTest.C
    chart/WChartTest.C
    json/JsonParserTest.C
    json/JsonSerializerTest.C
    json/JsonValueTest.C
    http/CookieTest.C
    http/HttpClientTest.C
    formdelegate/WFormDelegate.C
    mail/MailClientTest.C
    mail/MailMessageTest.C
    matrix/MatrixTest.C
    models/WBatchEditProxyModelTest.C
    models/WFormModelTest.C
    models/WModelIndexTest.C
    models/WStandardItemModelTest.C
    private/EscapeTest.C
    private/EventDecodeTest.C
    private/HttpTest.C
    private/CExpressionParserTest.C
    private/ColorTest.C
    private/I18n.C
    private/SessionFromCookieTest.C
    private/UrlManipTest.C
    render/BlockCssPropertyTest.C
    render/CssParserTest.C
    render/CssSelectorTest.C
    render/SpecificityTest.C
    render/WTextRendererTest.C
    strings/WStringTest.C
    types/WDateTest.C
    types/WDateTimeTest.C
    utf8/Utf8Test.C
    utf8/XmlTest.C
    utils/Base32Test.C
    utils/Base64Test.C
    utils/DateUtils.C
    utils/EraseWord.C
    utils/HtmlEncode.C
    utils/InfraUtils.C
    utils/ParseNumber.C
    utils/RoundJsString.C
    utils/XmlUtils.C
    validators/WEmailValidator.C
    widgets/WCompositeWidgetTest.C
    widgets/WContainerWidgetTest.C
    widgets/WDateEditTest.C
    widgets/WSpinBoxTest.C
    widgets/WStackedWidgetTest.C
    widgets/WTextTest.C
    widgets/WTreeViewTest.C
    length/WLengthTest.C
    color/WColorTest.C
    paintdevice/WSvgTest.C
    payment/MoneyTest.C
    locale/LocaleNumberTest.C
    trampoline/RefEncoder.C
    testenvironment/TestEnvironmentTest.C
    signals/SignalTest.C
    wdatetime/WDateTimeTest.C
    web/DomElementTest.C
  )

  set(thirdpartysources
    test.C
    thirdparty/qrcodegen/QrCode.C
  )

  add_executable(thirdpartytest.wt ${thirdpartysources})
  set_target_properties(thirdpartytest.wt PROPERTIES FOLDER "test/thirdparty")
  target_link_libraries(thirdpartytest.wt PRIVATE wt wttest ${BOOST_TEST_LIBRARIES})

  if(TARGET Boost::headers)
    target_link_libraries(thirdpartytest.wt PRIVATE Boost::headers)
  endif()

  if(WT_WITH_SSL)
    target_link_libraries(thirdpartytest.wt PRIVATE ${OPENSSL_LIBRARIES})
  endif()

  IF (WT_HAS_WRASTERIMAGE)
     SET(TEST_SOURCES ${TEST_SOURCES}
       paintdevice/WRasterTest.C
     )
  ENDIF(WT_HAS_WRASTERIMAGE)

  if(WT_WITH_SSL)
    set(TEST_SOURCES ${TEST_SOURCES} utils/SslUtils.C)
  endif()

  ADD_EXECUTABLE(test.wt
    ${TEST_SOURCES}
  )

  IF(MSVC)
    SET_TARGET_PROPERTIES(test.wt PROPERTIES FOLDER "test")
  ENDIF(MSVC)

  TARGET_LINK_LIBRARIES(test.wt PRIVATE wt wttest ${BOOST_TEST_LIBRARIES} ${BOOST_FS_LIB} ${WT_THREAD_LIB})

  IF(TARGET Boost::headers)
    TARGET_LINK_LIBRARIES(test.wt PRIVATE Boost::headers)
  ENDIF()

  if(WT_WITH_SSL)
    target_link_libraries(test.wt PRIVATE ${OPENSSL_LIBRARIES})
  endif()

  IF(ENABLE_LIBWTDBO)
    # Test all dbo backends
    SET(DBO_TEST_SOURCES
      test.C
      dbo/DboTest.C
      dbo/DboTest2.C
      dbo/DboTest3.C
      dbo/DboTest4.C
      dbo/DboTest5.C
      dbo/DboTest6.C
      dbo/DboTest7.C
      dbo/DboTest8.C
      dbo/DboTest9.C
      dbo/Benchmark.C
      dbo/Benchmark2.C
      dbo/JsonTest.C
      dbo/JsonTest2.C
      dbo/AuthDboTest.C
      dbo/DboTestCompositeKey.C
      auth/PasswordServiceTest.C
      private/DboImplTest.C
    )

    IF(HAVE_POSTGRES)
      ADD_EXECUTABLE(       test.postgres ${DBO_TEST_SOURCES})
      TARGET_LINK_LIBRARIES(test.postgres wt wttest wtdbo wtdbopostgres ${BOOST_TEST_LIBRARIES})
      SET_TARGET_PROPERTIES(test.postgres PROPERTIES COMPILE_FLAGS "-DPOSTGRES")
      IF(MSVC)
        SET_TARGET_PROPERTIES(test.postgres PROPERTIES FOLDER "test")
      ENDIF(MSVC)
      IF(TARGET Boost::headers)
        TARGET_LINK_LIBRARIES(test.postgres Boost::headers)
      ENDIF()
      MESSAGE("** Testing Wt::Dbo using Postgres backend")
    ENDIF(HAVE_POSTGRES)

    IF(HAVE_MYSQL)
      ADD_EXECUTABLE(       test.mysql ${DBO_TEST_SOURCES})
      TARGET_LINK_LIBRARIES(test.mysql wt wttest wtdbo wtdbomysql ${BOOST_TEST_LIBRARIES})
      SET_TARGET_PROPERTIES(test.mysql PROPERTIES COMPILE_FLAGS "-DMYSQL")
      IF(MSVC)
        SET_TARGET_PROPERTIES(test.mysql PROPERTIES FOLDER "test")
      ENDIF(MSVC)
      IF(TARGET Boost::headers)
        TARGET_LINK_LIBRARIES(test.mysql Boost::headers)
      ENDIF()
      MESSAGE("** Testing Wt::Dbo using Mysql backend")
    ENDIF(HAVE_MYSQL)

    IF(HAVE_ORACLE)
      ADD_EXECUTABLE(       test.oracle ${DBO_TEST_SOURCES})
      TARGET_LINK_LIBRARIES(test.oracle wt wttest wtdbo wtdbooracle ${BOOST_TEST_LIBRARIES})
      SET_TARGET_PROPERTIES(test.oracle PROPERTIES COMPILE_FLAGS "-DORACLE")
      IF(MSVC)
        SET_TARGET_PROPERTIES(test.oracle PROPERTIES FOLDER "test")
      ENDIF(MSVC)
      IF(TARGET Boost::headers)
        TARGET_LINK_LIBRARIES(test.oracle Boost::headers)
      ENDIF()
      MESSAGE("** Testing Wt::Dbo using Oracle backend")
    ENDIF(HAVE_ORACLE)

    IF(HAVE_FIREBIRD)
      ADD_EXECUTABLE(       test.firebird ${DBO_TEST_SOURCES})
      TARGET_LINK_LIBRARIES(test.firebird wt wttest wtdbo wtdbofirebird ${BOOST_TEST_LIBRARIES})
      SET_TARGET_PROPERTIES(test.firebird PROPERTIES COMPILE_FLAGS "-DFIREBIRD")
      IF(MSVC)
        SET_TARGET_PROPERTIES(test.firebird PROPERTIES FOLDER "test")
      ENDIF(MSVC)
      IF(TARGET Boost::headers)
        TARGET_LINK_LIBRARIES(test.firebird Boost::headers)
      ENDIF()
      MESSAGE("** Testing Wt::Dbo using Firebird backend")
    ENDIF(HAVE_FIREBIRD)

    IF(HAVE_SQLITE)
      ADD_EXECUTABLE(       test.sqlite3 ${DBO_TEST_SOURCES} dbo/SqliteTest.C)
      TARGET_LINK_LIBRARIES(test.sqlite3 wt wttest wtdbo wtdbosqlite3 ${BOOST_TEST_LIBRARIES})
      SET_TARGET_PROPERTIES(test.sqlite3 PROPERTIES COMPILE_FLAGS "-DSQLITE3")
      IF(MSVC)
        SET_TARGET_PROPERTIES(test.sqlite3 PROPERTIES FOLDER "test")
      ENDIF(MSVC)
      IF(TARGET Boost::headers)
        TARGET_LINK_LIBRARIES(test.sqlite3 Boost::headers)
      ENDIF()
      MESSAGE("** Testing Wt::Dbo using Sqlite3 backend")
    ENDIF(HAVE_SQLITE)

    IF(HAVE_MSSQLSERVER)
      ADD_EXECUTABLE(       test.mssqlserver ${DBO_TEST_SOURCES})
      TARGET_LINK_LIBRARIES(test.mssqlserver wt wttest wtdbo wtdbomssqlserver ${BOOST_TEST_LIBRARIES})
      SET_TARGET_PROPERTIES(test.mssqlserver PROPERTIES COMPILE_FLAGS "-DMSSQLSERVER")
      IF(MSVC)
        SET_TARGET_PROPERTIES(test.mssqlserver PROPERTIES FOLDER "test")
      ENDIF(MSVC)
      IF(TARGET Boost::headers)
          TARGET_LINK_LIBRARIES(test.mssqlserver Boost::headers)
      ENDIF()
      MESSAGE("** Testing Wt::Dbo using Microsoft SQL Server backend")
    ENDIF(HAVE_MSSQLSERVER)
  ENDIF(ENABLE_LIBWTDBO)

  INCLUDE_DIRECTORIES(${WT_SOURCE_DIR}/src)

  IF (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/interactive)
    SUBDIRS(interactive)
  ENDIF (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/interactive)

  IF(CONNECTOR_HTTP)
    SET(HTTP_TEST_SOURCES
      test.C
      http/HttpClientServerTest.C
    )

    ADD_EXECUTABLE(test.http ${HTTP_TEST_SOURCES})
    TARGET_LINK_LIBRARIES(test.http PRIVATE wt wthttp ${WT_THREAD_LIB} ${BOOST_TEST_LIBRARIES})
    IF(MSVC)
      SET_TARGET_PROPERTIES(test.http PROPERTIES FOLDER "test")
    ENDIF(MSVC)
    IF(TARGET Boost::headers)
      TARGET_LINK_LIBRARIES(test.http PRIVATE Boost::headers)
    ENDIF()
    if(WT_WITH_SSL)
      target_link_libraries(test.http PRIVATE ${OPENSSL_LIBRARIES})
    endif()
  ENDIF(CONNECTOR_HTTP)

ELSE (ENABLE_LIBWTTEST)
  MESSAGE("** libwttest disabled, not building tests")
ENDIF (ENABLE_LIBWTTEST)

=== examples/filedrop/CMakeLists.txt ===
#
# The ADD_EXAMPLE macro (defined in examples/CMakeLists.txt) ensures that
# the example is correctly built for the requested connector. It is equivalent
# to the following two lines:
#   ADD_EXECUTABLE(hello.wt hello.C)
#   TARGET_LINK_LIBRARIES(hello.wt ${EXAMPLES_CONNECTOR})
# except when the ISAPI (for Microsoft IIS) connector is used, where it will
# build a DLL with the proper symbols exported.
#
WT_ADD_EXAMPLE(filedrop.wt filedrop.C FileDropApplication.C custom_transfer/MyFileDropWidget.C custom_transfer/MyUploadResource.C)

#
# If you have Wt installed somewhere, you should use the
# installed Wt header files for your own Wt projects.
# e.g. INCLUDE_DIRECTORIES(/usr/local/include)
# instead of the following:
#
INCLUDE_DIRECTORIES(${WT_SOURCE_DIR}/src)

=== examples/widgetgallery/CMakeLists.txt ===
IF(BOOST_WT_FOUND)
SET(WIDGETGALLERY_SOURCES
  main.C
  BaseTemplate.h BaseTemplate.C
  DeferredWidget.h
  FormWidgets.h FormWidgets.C
  GraphicsWidgets.h GraphicsWidgets.C
  Layout.h Layout.C
  Media.h Media.C
  Navigation.h Navigation.C
  Sample.h
  Theme.h Theme.C
  Topic.h Topic.C
  TopicTemplate.h TopicTemplate.C
  TreesTables.h TreesTables.C
  WidgetGallery.h WidgetGallery.C
  ../treeview-dragdrop/CsvUtil.h ../treeview-dragdrop/CsvUtil.C
  examples/DataModels.h examples/DataModels.cpp
)
# no popen on windows
IF(NOT WIN32)
SET(WIDGETGALLERY_SOURCES
  ${WIDGETGALLERY_SOURCES}
  ../gitmodel/Git.h ../gitmodel/Git.C
)
ENDIF(NOT WIN32)

WT_ADD_EXAMPLE(widgetgallery.wt
  ${WIDGETGALLERY_SOURCES}
)

if(NOT WIN32)
  target_link_libraries(widgetgallery.wt ${BOOST_FS_LIB} ${BOOST_SYSTEM_LIB})
endif()

IF(TARGET Boost::headers)
  TARGET_LINK_LIBRARIES(widgetgallery.wt Boost::headers)
ENDIF()

if(HAVE_HARU)
  target_link_libraries(widgetgallery.wt HPDF::HPDF)
endif()

#
# If you have Wt installed somewhere, you should use the
# installed Wt header files for your own Wt projects.
# e.g. INCLUDE_DIRECTORIES(/usr/local/include)
# instead of the following:
#
target_include_directories(widgetgallery.wt PRIVATE ${WT_SOURCE_DIR}/src)

ELSE(BOOST_WT_FOUND)
  MESSAGE(STATUS "** Not building widgetgallery example: requires boost headers.")
ENDIF(BOOST_WT_FOUND)

=== src/Wt/CMakeLists.txt ===
SUBDIRS(Auth Core Chart Dbo Form Json Http Mail Payment Render Signals Test)

INSTALL_FILES(/include/Wt "^W.*[.]h$")
INSTALL_FILES(/include/Wt "^Utils[.]h$")
INSTALL_FILES(/include/Wt "^cpp17$")
INSTALL_FILES(/include/Wt "^cpp20$")
INSTALL_FILES(/include/Wt "^AsioWrapper$")
#INSTALL(
#  FILES
#    "^W.*[^C~]$"
#    ${WCONFIG_H_PATH}
#  DESTINATION include
#)

if(ASCIIDOCTOR_FOUND)
  ASCIIDOC_FILE(wt-tutorial
    ${WT_SOURCE_DIR}/doc/tutorial/wt.adoc
    ${WT_SOURCE_DIR}/doc/tutorial/wt.html)
endif()

IF (WT_DATE_TZ_USE_DATE)
  ADD_SUBDIRECTORY(Date)
ENDIF()

=== src/http/CMakeLists.txt ===
IF(CONNECTOR_HTTP)
  MESSAGE("** Enabling built-in httpd.")

  # Wt uses strstrcase for case insensitive ASCII string
  # comparisons on Linux for performance reasons. This function is however
  # not supported on many platforms (windows, solaris)
  INCLUDE(CheckFunctionExists)
  CHECK_FUNCTION_EXISTS(strcasestr HAVE_STRCASESTR)
  IF (HAVE_STRCASESTR)
    ADD_DEFINITIONS(-DHAVE_STRCASESTR)
  ENDIF (HAVE_STRCASESTR)
  CHECK_FUNCTION_EXISTS(strcasecmp HAVE_STRCASECMP)
  IF (HAVE_STRCASECMP)
    ADD_DEFINITIONS(-DHAVE_STRCASECMP)
  ENDIF (HAVE_STRCASECMP)
  CHECK_FUNCTION_EXISTS(strncasecmp HAVE_STRNCASECMP)
  IF (HAVE_STRNCASECMP)
    ADD_DEFINITIONS(-DHAVE_STRNCASECMP)
  ENDIF (HAVE_STRNCASECMP)

  SET(libhttpsources
    Android.h Android.C
    Configuration.h Configuration.C
    Connection.h Connection.C
    ConnectionManager.h ConnectionManager.C
    HTTPRequest.h HTTPRequest.C
    MimeTypes.h MimeTypes.C
    ProxyReply.h ProxyReply.C
    Reply.h Reply.C
    Request.h Request.C
    RequestHandler.h RequestHandler.C
    RequestParser.h RequestParser.C
    Server.h Server.C
    SessionProcess.h SessionProcess.C
    SessionProcessManager.h SessionProcessManager.C
    SslConnection.h SslConnection.C
    StaticReply.h StaticReply.C
    StockReply.h StockReply.C
    TcpConnection.h TcpConnection.C
    WServer.C
    WtReply.h WtReply.C
  )

 OPTION(HTTP_WITH_ZLIB "Support for zlib (http compression)" ${ZLIB_FOUND})

 IF(WIN32)
   IF(SHARED_LIBS)
     CONFIGURE_FILE(wthttp-version.rc.in
                    ${CMAKE_CURRENT_BINARY_DIR}/wthttp-version.rc)
     SET(libhttpsources ${libhttpsources}
         ${CMAKE_CURRENT_BINARY_DIR}/wthttp-version.rc)
   ENDIF(SHARED_LIBS)

# boost asio has a serious bug causing subtle data corruption
# https://svn.boost.org/trac/boost/ticket/8935
# https://svn.boost.org/trac/boost/ticket/8933
  IF (Boost_VERSION EQUAL 105400 OR Boost_VERSION STREQUAL "1.54.0")
    MESSAGE(FATAL_ERROR "** boost 1.54 is blacklisted for httpd on Windows (boost ticket #8935)")
  ENDIF ()
 ENDIF(WIN32)

 IF (HAVE_SSL)
    SET(MY_SSL_LIBS ${OPENSSL_LIBRARIES})
    ADD_DEFINITIONS(-DHTTP_WITH_SSL)
 ELSE (HAVE_SSL)
    SET(MY_SSL_LIBS "")
 ENDIF (HAVE_SSL)

 IF(NOT BOOST_WTHTTP_FOUND)

    MESSAGE(FATAL "** Could not find all boost libraries required to build the httpd connector (thread, filesystem, programoptions, datetime)")

  ENDIF(NOT BOOST_WTHTTP_FOUND)
  IF(HTTP_WITH_ZLIB)
    ADD_DEFINITIONS(-DWTHTTP_WITH_ZLIB ${ZLIB_DEFINITIONS})
    SET(MY_ZLIB_LIBS ${ZLIB_LIBRARIES})
    INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIRS})
  ELSE(HTTP_WITH_ZLIB)
    SET(MY_ZLIB_LIBS "")
  ENDIF(HTTP_WITH_ZLIB)

  INCLUDE_DIRECTORIES(
    ${BOOST_INCLUDE_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/../web
    ${CMAKE_CURRENT_SOURCE_DIR}/../wt
    ${CMAKE_CURRENT_BINARY_DIR}/
  )

  ADD_DEFINITIONS(${ZLIB_DEFINITIONS})
  ADD_LIBRARY(wthttp ${libhttpsources})

  if(NOT APPLE OR SHARED_LIBS)
    SET_PROPERTY(TARGET wthttp PROPERTY C_VISIBILITY_PRESET hidden)
    SET_PROPERTY(TARGET wthttp PROPERTY CXX_VISIBILITY_PRESET hidden)
    SET_PROPERTY(TARGET wthttp PROPERTY VISIBILITY_INLINES_HIDDEN YES)
  endif()

  TARGET_LINK_LIBRARIES(wthttp
    PUBLIC
      wt
    PRIVATE
      ${MY_ZLIB_LIBS}
      ${MY_SSL_LIBS}
      ${BOOST_WTHTTP_LIBRARIES}
      ${WT_SOCKET_LIBRARY}
      ${WIN32_STRSTRI_LIB}
  )

  IF(BOOST_WT_MT_FOUND)
    TARGET_LINK_LIBRARIES(wthttp PRIVATE ${WT_THREAD_LIB})
  ENDIF(BOOST_WT_MT_FOUND)

  INSTALL(TARGETS wthttp
    EXPORT wt-target-http
    RUNTIME DESTINATION bin
    LIBRARY DESTINATION ${LIB_INSTALL_DIR}
    ARCHIVE DESTINATION ${LIB_INSTALL_DIR})

  INSTALL(EXPORT wt-target-http
          DESTINATION ${CMAKE_INSTALL_DIR}/wt
          NAMESPACE Wt::)

  SET_TARGET_PROPERTIES(
    wthttp
  PROPERTIES
    EXPORT_NAME HTTP
    VERSION ${VERSION_SERIES}.${VERSION_MAJOR}.${VERSION_MINOR}
    DEBUG_POSTFIX ${DEBUG_LIB_POSTFIX}
  )

  IF(MSVC)
    SET_TARGET_PROPERTIES(
        wthttp
      PROPERTIES
        COMPILE_FLAGS "${BUILD_PARALLEL} /wd4251 /wd4275 /wd4355 /wd4800 /wd4996 /wd4101 /wd4267 /wd4267"
    )
  ENDIF(MSVC)

  ADD_DEPENDENCIES(wthttp wt ${EXAMPLES_CONNECTOR})

ELSE(CONNECTOR_HTTP)
  MESSAGE("** Disabling built-in httpd.")
ENDIF(CONNECTOR_HTTP)

=== src/isapi/CMakeLists.txt ===
IF(CONNECTOR_ISAPI)
  IF(NOT MULTI_THREADED)
    MESSAGE("** Disabling ISAPI because MULTI_THREADED is disabled.")
  ELSE(NOT MULTI_THREADED)
    MESSAGE("** Enabling ISAPI.")

    ADD_DEFINITIONS(-D_WIN32_WINNT=0x0600 -DWTISAPI_STATIC)

    SET(libsapisources
      Server.h Server.C
      WServer.C
      Isapi.C
      IsapiRequest.h IsapiRequest.C
      IsapiStream.h IsapiStream.C
    )

    INCLUDE_DIRECTORIES(${FCGI_INCLUDE_DIRS})

    ADD_LIBRARY(wtisapi STATIC ${libsapisources})
    TARGET_LINK_LIBRARIES(wtisapi PUBLIC wt)

    IF(TARGET Boost::headers)
      TARGET_LINK_LIBRARIES(wtisapi PRIVATE Boost::headers)
    ENDIF()

    SET_TARGET_PROPERTIES(
      wtisapi
    PROPERTIES
      EXPORT_NAME Isapi
      VERSION ${VERSION_SERIES}.${VERSION_MAJOR}.${VERSION_MINOR}
      DEBUG_POSTFIX ${DEBUG_LIB_POSTFIX}
    )
    IF(MSVC)
      SET_TARGET_PROPERTIES(
          wtisapi
        PROPERTIES
          COMPILE_FLAGS "${BUILD_PARALLEL} /wd4267 /wd4251 /wd4275"
          COMPILE_PDB_NAME "wtisapi"
          COMPILE_PDB_NAME_DEBUG "wtisapi${DEBUG_LIB_POSTFIX}"
      )
    ENDIF(MSVC)

    INSTALL(TARGETS wtisapi
      EXPORT wt-target-isapi
      RUNTIME DESTINATION bin
      LIBRARY DESTINATION ${LIB_INSTALL_DIR}
      ARCHIVE DESTINATION ${LIB_INSTALL_DIR})

    INSTALL(EXPORT wt-target-isapi
            DESTINATION ${CMAKE_INSTALL_DIR}/wt
            NAMESPACE Wt::)

  ENDIF(NOT MULTI_THREADED)

ELSE(CONNECTOR_ISAPI)
  MESSAGE("** Disabling ISAPI.")
ENDIF(CONNECTOR_ISAPI)

=== src/web/CMakeLists.txt ===
INSTALL_FILES(/include/Wt DomElement.h)
INSTALL_FILES(/include/Wt EscapeOStream.h)

=== src/Wt/Auth/CMakeLists.txt ===
SUBDIRS(Dbo)

FILE(GLOB AUTH_H_FILES RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "*.h")
LIST(REMOVE_ITEM AUTH_H_FILES MailUtils.h passwdqc.h)
INSTALL(FILES ${AUTH_H_FILES}
        DESTINATION include/Wt/Auth)

if(ASCIIDOCTOR_FOUND)
  ASCIIDOC_FILE(auth-tutorial
    ${WT_SOURCE_DIR}/doc/tutorial/auth.adoc
    ${WT_SOURCE_DIR}/doc/tutorial/auth.html)
endif()

if(WT_HAS_SAML)
  add_subdirectory(Saml)
endif()

add_subdirectory(Mfa)

=== src/Wt/Core/CMakeLists.txt ===
INSTALL_FILES(/include/Wt/Core "^.*[.]hpp$")

=== src/Wt/Date/CMakeLists.txt ===
INSTALL_FILES(/include/Wt/Date "^.*[.]h")
INSTALL_FILES(/include/Wt/Date "^include$")

=== PKGBUILD ===
# Maintainer: Konstantin Podsvirov <konstantin@podsvirov.su>

_realname=wt
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=4.11.1
pkgrel=1
pkgdesc="A C++ library and application server for developing and deploying web applications (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="http://www.webtoolkit.eu/"
msys2_repository_url="https://github.com/emweb/wt"
license=('spdx:GPL-2.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-cc-libs"
         "${MINGW_PACKAGE_PREFIX}-boost-libs"
         "${MINGW_PACKAGE_PREFIX}-fontconfig"
         "${MINGW_PACKAGE_PREFIX}-glib2"
         "${MINGW_PACKAGE_PREFIX}-glew"
         "${MINGW_PACKAGE_PREFIX}-graphicsmagick"
         "${MINGW_PACKAGE_PREFIX}-libharu"
         "${MINGW_PACKAGE_PREFIX}-libwinpthread"
         "${MINGW_PACKAGE_PREFIX}-openssl"
         "${MINGW_PACKAGE_PREFIX}-pango"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-doxygen"
             "${MINGW_PACKAGE_PREFIX}-graphviz"
             "${MINGW_PACKAGE_PREFIX}-asciidoc"
             "${MINGW_PACKAGE_PREFIX}-boost"
             "${MINGW_PACKAGE_PREFIX}-python-setuptools"
             "${MINGW_PACKAGE_PREFIX}-python-pygments"
             "${MINGW_PACKAGE_PREFIX}-postgresql"
             "${MINGW_PACKAGE_PREFIX}-libmariadbclient"
             "${MINGW_PACKAGE_PREFIX}-sqlite3"
             "${MINGW_PACKAGE_PREFIX}-qt5-tools"
             "${MINGW_PACKAGE_PREFIX}-qt6-tools")
optdepends=("${MINGW_PACKAGE_PREFIX}-postgresql: for PostgreSQL Dbo support"
            "${MINGW_PACKAGE_PREFIX}-libmariadbclient: for MySQL Dbo support"
            "${MINGW_PACKAGE_PREFIX}-sqlite3: for Sqlite Dbo support")
source=("${msys2_repository_url}/archive/${pkgver}/${_realname}-${pkgver}.tar.gz"
         '001-wt-4.4.0-fix-find-gm.patch'
         '002-wt-4.4.0-skip-some-examples.patch'
         '003-wt-4.4.0-disable-win32-configdir.patch'
         '004-wt-4.4.0-disable-win32-examples-bat.patch'
         '005-fix-build-with-boost-1.87.patch::https://github.com/emweb/wt/commit/f39d3a00.patch')
sha256sums=('c255b7d6b0569a9c67282ef7a89af9624e3ab79477924e5a110814a570d1d017'
            '8e42ec247e796117363d8cbfad7b36ba2e4387597f431adbc8846e4ae78d6610'
            '325181981bd46cca61592e501448717b0451be167ad8e3e46ba84ec2cdd42574'
            '746aaec5c34b1725514111a29376d5484cf7c9e23cc3d2f16e737f32c67211c6'
            'e0bcd9a9b5bff0e3b13cc49dc029d35ec36a42e61c0449ddee97b21d2c4e39a6'
            '993a99571ab23a8078dd301e09cedc0da13aa3d27d9e5b819d31b7d0653ac3a8')

apply_patch_with_msg() {
  for _fname in "$@"
  do
    msg2 "Applying ${_fname}"
    patch -Nbp1 -i "${srcdir}"/${_fname}
  done
}

prepare() {
  cd "${srcdir}/${_realname}-${pkgver}"

  apply_patch_with_msg \
    001-wt-4.4.0-fix-find-gm.patch \
    002-wt-4.4.0-skip-some-examples.patch \
    003-wt-4.4.0-disable-win32-configdir.patch \
    004-wt-4.4.0-disable-win32-examples-bat.patch \
    005-fix-build-with-boost-1.87.patch

  find . -name "*.orig" -exec rm -f {} \;
}

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    -G"Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    "${_extra_config[@]}" \
    -DCONNECTOR_HTTP=ON \
    -DWT_WRASTERIMAGE_IMPLEMENTATION=GraphicsMagick \
    -DGM_PREFIX=${MINGW_PREFIX} \
    -DWEBUSER=http \
    -DWEBGROUP=http \
    -DUSE_SYSTEM_SQLITE3=ON \
    -DBUILD_EXAMPLES=OFF \
    -DINSTALL_EXAMPLES=ON \
    -DINSTALL_DOCUMENTATION=ON \
    -DBUILD_TESTS=OFF \
    -DSHARED_LIBS=ON \
    -DBOOST_DYNAMIC=ON \
    -DHARU_DYNAMIC=ON \
    -DMYSQL_PREFIX=${MINGW_PREFIX} \
    ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  local PREFIX_WIN=$(cygpath -wm ${MINGW_PREFIX})
  for _f in "${pkgdir}${MINGW_PREFIX}"/lib/cmake/wt/*.cmake; do
    sed -e "s|${PREFIX_WIN}|\$\{_IMPORT_PREFIX\}|g" -i ${_f}
    sed -e "s|${MINGW_PREFIX}|\$\{_IMPORT_PREFIX\}|g" -i ${_f}
  done

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}
